<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SmsService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">astrapay-otp</a> &gt; <a href="index.source.html" class="el_package">com.astrapay.otp.service</a> &gt; <span class="el_source">SmsService.java</span></div><h1>SmsService.java</h1><pre class="source lang-java linenums">package com.astrapay.otp.service;

import com.astrapay.otp.bean.SmsContent;
import com.astrapay.otp.model.SmsCredential;
import com.astrapay.otp.model.SmsLog;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Service
<span class="fc" id="L19">public class SmsService {</span>
<span class="fc" id="L20">    private final Logger log = LoggerFactory.getLogger(this.getClass());</span>
    
    @Value(&quot;${service-sms-url}&quot;)
    private String urlOtp;

    @Autowired
    private  SmsTemplateService smsTemplateService;
    @Autowired
    private  SmsCredentialService smsCredentialService;
    @Autowired
    private SmsLogService smsLogService;
    public Map&lt;String,String&gt; sendSms(String phoneNumber, String otp, String messageTemplateTransactionOtp) throws Exception {
<span class="nc" id="L32">		SmsContent smsdto = new SmsContent(otp);</span>
<span class="nc" id="L33">		smsdto.setType(&quot;Pembayaran&quot;);</span>
<span class="nc" id="L34">        String message = smsTemplateService.setMessageWithParam(messageTemplateTransactionOtp, smsdto);</span>
<span class="nc" id="L35">        String otpResponse = sendSmsNotif(phoneNumber, message, 19L, &quot;pembayaran&quot;);</span>
<span class="nc" id="L36">        Map&lt;String,String&gt; map = new HashMap&lt;&gt;();</span>
<span class="nc bnc" id="L37" title="All 2 branches missed.">        if(otpResponse.equals(&quot;error&quot;)){</span>
<span class="nc" id="L38">            map.put(&quot;Status&quot;,otpResponse);</span>
        } else {
<span class="nc" id="L40">            String[] split = otpResponse.split(&quot;=&quot;);</span>
<span class="nc" id="L41">            int splitLength = split.length;</span>
<span class="nc bnc" id="L42" title="All 2 branches missed.">            if(splitLength&gt;1){</span>
<span class="nc" id="L43">                String[] params = otpResponse.split(&quot;&amp;&quot;);</span>
<span class="nc bnc" id="L44" title="All 2 branches missed.">                for (String param : params)  </span>
                {  
<span class="nc" id="L46">                    String names =&quot;&quot;;</span>
<span class="nc" id="L47">                    String values =&quot;&quot;;</span>
<span class="nc" id="L48">                    split = param.split(&quot;=&quot;);</span>
<span class="nc bnc" id="L49" title="All 2 branches missed.">                    if(splitLength&gt;0){</span>
<span class="nc" id="L50">                        names = split[0];</span>
<span class="nc" id="L51">                        values = split[1];</span>
<span class="nc" id="L52">                        map.put(names,values);</span>
                    }
                }
            }
        }
<span class="nc" id="L57">		return map;</span>
    }
    
    private String sendSmsNotif(String phoneNumber, String message, Long organizationId, String trxId)
			throws Exception {
<span class="nc" id="L62">		String oriMessage = message;</span>
<span class="nc" id="L63">		Map&lt;String, String&gt; otpData = new HashMap&lt;String, String&gt;();</span>
<span class="nc" id="L64">		String phone = phoneNumber;</span>
<span class="nc bnc" id="L65" title="All 2 branches missed.">		if (phone.startsWith(&quot;08&quot;))</span>
<span class="nc" id="L66">			phone = phone.replaceFirst(&quot;08&quot;, &quot;628&quot;);</span>
<span class="nc bnc" id="L67" title="All 2 branches missed.">		else if (phone.startsWith(&quot;+628&quot;))</span>
<span class="nc" id="L68">			phone = phone.substring(1);</span>
        
<span class="nc" id="L70">		SmsCredential sms = smsCredentialService.getSmsCredentialByOrganizationId(organizationId);</span>
<span class="nc" id="L71">		message = message.replace(&quot; &quot;, &quot;%20&quot;);</span>
<span class="nc" id="L72">		message = message.replace(&quot;.&quot;, &quot;%2E&quot;);</span>
<span class="nc" id="L73">		String[] value, mandatoryAtribut = { &quot;userid&quot;, &quot;password&quot;, &quot;msisdn&quot;, &quot;message&quot;, &quot;sender&quot;, &quot;division&quot;,</span>
				&quot;batchname&quot;, &quot;uploadby&quot;, &quot;channel&quot;, &quot;trxID&quot; };
<span class="nc" id="L75">		String[] defaultValue = { &quot;astrada&quot;, &quot;astrada235&quot;, phone, message, &quot;ASTRAPAY&quot;, &quot;Business%20Development%20%26%20Marketing&quot;, &quot;AstraPay_&quot;, &quot;astrapay&quot;,</span>
				&quot;2&quot;, trxId };
<span class="nc bnc" id="L77" title="All 2 branches missed.">		if (sms == null)</span>
<span class="nc" id="L78">			value = defaultValue;</span>
		else
<span class="nc" id="L80">			value = new String[] { sms.getUserId(), sms.getPassword(), phone, message, sms.getSender(),</span>
<span class="nc" id="L81">					sms.getDivision(), &quot;AstraPay_&quot;, sms.getUploadBy(), sms.getChannel(), trxId };</span>

<span class="nc bnc" id="L83" title="All 2 branches missed.">		for (String param : mandatoryAtribut) {</span>
<span class="nc" id="L84">			int valueIndex = Arrays.asList(mandatoryAtribut).indexOf(param);</span>
<span class="nc bnc" id="L85" title="All 2 branches missed.">			otpData.put(param, value[valueIndex] == null ? defaultValue[valueIndex] : value[valueIndex]);</span>
		}
<span class="nc" id="L87">		String otpResponse = &quot;&quot;;</span>
<span class="nc" id="L88">		otpResponse = new PushAPI().sendGetAPI(otpData, urlOtp);</span>
<span class="nc" id="L89">        log.info(&quot;RESPONSE OTP&quot;);</span>
<span class="nc" id="L90">        log.info(otpResponse);</span>
        
<span class="nc" id="L92">        SmsLog smsLog = new SmsLog();</span>
<span class="nc" id="L93">		smsLog.setDate(new Date());</span>
<span class="nc" id="L94">		smsLog.setPhoneNumber(phoneNumber);</span>
<span class="nc" id="L95">		smsLog.setMessage(oriMessage);</span>
<span class="nc" id="L96">		smsLog.setResponse(otpResponse);</span>
<span class="nc" id="L97">		smsLogService.save(smsLog);</span>
<span class="nc" id="L98">        return otpResponse;</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.5.201910111838</span></div></body></html>